<template>
	<el-select
		ref="elSelectRef"
		v-bind="attrs"
		:model-value="value"
		:loading="loading"
		@update:model-value="updateValue"
	>
		<el-option
			v-for="({ key, value }) of items"
			:key="key"
			:label="`${value}`"
			:value="key"
			placeholder="Select"
		/>
	</el-select>
</template>

<script setup lang="ts">
import { ref, computed, watch, PropType, onMounted, VNode, useAttrs, ComponentPublicInstance } from "vue";
import { ElSelect, ElOption } from "element-plus";
import { Task } from "../../../lib/types";
import { moveCursor } from "../../ts/utils";

type ValueType = string | number;

interface Item {
	key: ValueType;
	value: string;
}

const props = defineProps({
	modelValue: {
		type: [String, Number],
	},
	initData: {
		type: Object as PropType<Item[]>
	},
	data: {
		type: Object as PropType<Item[]>
	},
	remote: {
		type: Function as PropType<(val: string) => Task<Item[]>>
	}
});

const emit = defineEmits(["update:modelValue"]);
const inputAttrs = useAttrs();

const value = ref(props.modelValue);
const items = ref<Item[]>();
const loading = ref<boolean>(false);

const elSelectRef = ref<ComponentPublicInstance>();

const attrs = computed(() => {
	const isRemote = props.remote !== undefined;

	if (!isRemote) {
		return {};
	}

	if (isRemote) {
		return {
			remote: true,
			filterable: true,
			reserveKeyword: true,
			// multiple: true,
			remoteMethod: async (query: string): Promise<void> => {
				if (!props.remote) {
					return;
				}

				loading.value = true;

				return props.remote(query)()
					.then(x => {
						console.log('remote', x);
						items.value = x;
					})
					.catch(() => {
						console.log('remote', 'catch');
						items.value = [];
					})
					.finally(() => {
						loading.value = false;
					});
			}
		}
	}


});

onMounted(init);

function init() {
	const data = props.initData || props.data;
	const found = data && data.find(x => x.key === props.modelValue);
	items.value = found ? data : [];

	setInput(input => {
		for (const name in inputAttrs) {
			const val = inputAttrs[name];
			if (val === null || val === undefined) continue;

			input.setAttribute(name, String(val));
		}
	});
}

watch(() => [...props.data || []], (data) => {
	items.value = data;
	if (!data.find(x => x.key === props.modelValue)) {
		updateValue(undefined);
	}
});

watch(() => props.modelValue, (newValue) => updateValue(newValue));

function updateValue(val?: ValueType) {
	value.value = val;
	// window.setTimeout(() => {
	// 	const elSelect = elSelectRef.value?.$el;

	// 	if (!elSelect) return;

	// 	elSelect.blur();

	// 	const input = elSelect.querySelector('input');

	// 	if (!input) return;

	// 	moveCursor(input, 0);
	// }, 200);
	emit("update:modelValue", val);
}

function setInput(clb: (input: HTMLInputElement) => void) {
	const elSelect: HTMLElement | null = elSelectRef.value?.$el;

	if (!elSelect) return;

	const input = elSelect.querySelector('input');

	if (!input) return;

	clb(input);
}

</script>

<style lang="scss" scoped>
</style>